''*******************************************************
''*  Putty Telnet Wireless WX Val-From-Micro Demo       *
''*  Author: Clock Loop @ parallax forums               *
''*  Upload the webpage val-from-micro.html to your WX  *
''*  Visit http://192.168.4.1/files/val-from-micro.html *
''*  I did not make the html, parallax did?             *          
''*******************************************************


CON 
  _CLKMODE=XTAL1 + PLL16X                   ' The system clock spec
  _XINFREQ = 5_000_000                                  ' Crystal

  Rx        = 31     'serial in from wx device
  Tx        = 30     'serial out to wx device

OBJ

    ser: "Parallax Serial Terminal.spin"

VAR
    byte   LoopCounter
    long   Stack1[100]

Pub Main   

cognew(Comms, @Stack1)

Pub Comms | CommandMode, Reply1, Reply2, Reply3, Reply4, Reply5, Reply6, Reply7, ReplyStatus
    
  ser.StartRxTx(RX, TX, 0, 115200)   'Cog #2 
  waitcnt(80_000_000 + cnt)   'wait 1 second for serial to start.
            
  Repeat                'The main repeat loop.
    ser.str(string(27))     'Set ansi command mode in putty.
    ser.str(string("[2J"))  'Clear putty telnet screen. 

    ser.str(string(27))      'Set ansi command mode in putty.                                             
    ser.str(string("[4;3f")) 'Set Position in putty
                                                           
    If ReplyStatus == 1     
      ser.str(string("Good reply."))   'If last reply was good, put it back up on putty which was cleared.                
    Else
      ser.str(string(" Bad reply."))    'If last reply was bad, put it back up on putty which was cleared.   

    ser.str(string(27))      'Set ansi command mode in putty.                                             
    ser.str(string("[5;3f")) 'Set Position in putty to put cursor at 0 
    ser.str(string("Loop count number that should be shown on webpage: ")) '
    ser.dec(LoopCounter) 

    ser.str(string(27))      'Set ansi command mode in putty.                                               
    ser.str(string("[1;1f")) 'Set Position in putty to put cursor at 0

    If CommandMode == 1    'Check for command mode on in spin.
      
      ser.str(string(27))      'Set ansi command mode in putty.                 
      ser.str(string("[2;3f")) 'Set Position in putty.      
      ser.str(string("Command Mode is On. ")) 'Tell putty command mode is on.                       
      ser.str(string(27))      'Set ansi command mode in putty.      
      ser.str(string("[1;1f")) 'Set Position in putty to put cursor at 0
      
      
      waitcnt(80_000_000 + cnt)   'wait 1 second for serial to stop.
      ser.Stop              'Turn off serial to send break.
    
      dira[TX]~~          ' Set direction to output
      outa[TX]:= 0        ' Set TX low.                         
      waitcnt(80_000_000 + cnt)   'wait 1 second for command mode to start in the module.
      dira[TX]~           ' Set direction to input  

      ser.StartRxTx(RX, TX, 0, 115200)   'Cog #2                                  
      waitcnt(80_000_000 + cnt)   'wait 1 second for serial to start.
                             
      ser.char(254)  'Begin marker
      ser.str(string("LISTEN:HTTP,/tpfm"))   'Tell the module to listen to a specific path on http port 80.
      ser.char(13)    'End marker  
      waitcnt(80_000_000 + cnt)   'wait 1 second 
                     
      ReplyStatus := 0     'Set the reply to bad so it can recheck for a new reply.
    
      Repeat 10
        ser.rxflush
        ser.char(254)  'Begin marker
        ser.str(string("POLL:"))   'Tell the module to listen to a ANY protocol/path.
        ser.char(13)    'End marker
        waitcnt(80_000_000 + cnt) 'Wait for 1 s for rx buffer to fill.
        Reply1 := ser.rxcheck   ' should be 254
        Reply2 := ser.rxcheck   ' should be =
        Reply3 := ser.rxcheck   ' should be G
        Reply4 := ser.rxcheck   ' should be ,
        Reply5 := ser.rxcheck   ' should be 5  (this could change)
        Reply6 := ser.rxcheck   ' should be ,
        Reply7 := ser.rxcheck   ' should be 1
        waitcnt(80_000_000 + cnt) 'Wait for 1 s 
                                  '
        If Reply1 == 254 And Reply2 == "=" And Reply3 == "G"
          ReplyStatus := 1     'Set the reply to good so it can be shown in putty.
          
          ser.char(254)               'Begin marker
          ser.str(string("REPLY:")) 'Tell the module to send a reply to the poll response.
          ser.char(Reply5)            'Should be a number.   An active connection handle; returned by POLL.
          ser.str(string(","))      'Required for a reply
          ser.str(string("200"))    'The desired HTTP response code for the reply.                         
          ser.str(string(","))      'Required for a reply
          
          If LoopCounter < 10
            ser.str(string("1"))      'Tell the module how many bytes? (or is this digits?) the reply is.
          
          Elseif LoopCounter > 9 AND LoopCounter < 100
            ser.str(string("2"))      'Tell the module how many bytes? (or is this digits?) the reply is.
          
          Else 
            ser.str(string("3"))      'Tell the module how many bytes? (or is this digits?) the reply is. 
                
          ser.char(13)                'End marker
          ser.dec(LoopCounter)      'Send 1 byte (which is up to 3 characters (in decimal) (254) of data to the module which then sends it to the webpage.
              
      waitcnt(80_000_000 + cnt) 'Wait for 1 s 
      ser.char(254)  'Begin marker
      ser.str(string("SET:cmd-enable,0"))   'Turn command mode off in the WX module.
      ser.char(13)    'End marker
      CommandMode := 0  'Turn command mode off in spin.
                        '     
    ser.str(string(27))      'Set ansi command mode in putty.
    ser.str(string("[2;3f")) 'Set Position in putty.
    ser.str(string("Command Mode is Off."))   'Tell putty command mode is off.                                                                                                          
    
    ser.str(string(27))      'Set ansi command mode in putty.                                             
    ser.str(string("[4;3f")) 'Set Position in putty to put cursor at 0                                                                                               

    If ReplyStatus == 1      
      ser.str(string("Good reply."))  
                                                                      
    Else
      ser.str(string(" Bad reply.")) 

    ser.str(string(27))      'Set ansi command mode in putty.                                             
    ser.str(string("[5;3f")) 'Set Position in putty
    ser.str(string("Loop count number that should be shown on webpage: ")) '
    ser.dec(LoopCounter)
    
    ser.str(string(27))      'Set ansi command mode in putty.                                               
    ser.str(string("[1;1f")) 'Set Position in putty to put cursor at 0
    
    Repeat 5
      waitcnt(80_000_000 + cnt) 'Wait for 1 s 
              
    CommandMode := 1   'Turn command mode on in spin.
    LoopCounter++
    If LoopCounter > 254  'Deal with rollover.
      LoopCounter := 0 


{{
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
//                                                  TERMS OF USE: MIT License
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
// Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation
// files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy,
// modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the
// Software is furnished to do so, subject to the following conditions:
//
// The above copyright notice and this permission notice shall be included in all copies or substantial portions of the
// Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE
// WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR
// COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
// ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////      
}}   